/// funcs.js dependent
function delpnd(hex) {
  var s = hex;
  if (s.substr(0,1) == "#") s=s.substr(1);
  return s;
}
function Hex2RGB(hex) {
  var h = delpnd(hex);
  return [ parseInt(h.substring(0,2),16),
  parseInt(h.substring(2,4),16),
  parseInt(h.substring(4,6),16) ];
}
function RGB2Hex(n) {
  var rgb = roundv(n,0); // could be in float so round to int.
  var h="", a, b;
  var hexa = ["0","1","2","3","4","5","6","7","8",
              "9","A","B","C","D","E","F"];
  for (var i=0;i<3;i++) {
    a = Math.floor(rgb[i] / 16);
    b = intr(rgb[i]) - a * 16;
    h += hexa[a];
    h += hexa[b];
  }
  return "#"+h;
}

function HexToRGB(hex) {
  var h = hex;
  if (left(hex,1) == "#") h = right(hex,-1);
  var r = mid(h,1,2);
  var g = mid(h,3,2);
  var b = mid(h,5,2);
  return [parseInt(r,16),parseInt(g,16),parseInt(b,16)];
}
function Hex(n) {
  var hex = Number(n).toString(16);
  if (hex.length < 2) { hex = "0" + hex; }
  return hex.toUpperCase();
}
function RGBToHex(rgb) {
return "#" + Hex(rgb[0]) + Hex(rgb[1]) + Hex(rgb[2]);
}
/// H,S,L in range of 0-1
function hsl2rgb(h, s, l) {
  if ((h > 1) || (h < 0)) { echo("H out of range");return [0,0,0]; }
  if ((s > 1) || (s < 0)) { echo("S out of range");return [0,0,0]; }
  if ((l > 1) || (l < 0)) { echo("L out of range");return [0,0,0]; }
  if (l <= 0.5) v = (l * (1.0 + s));
  else v = (l + s - l * s);

  if (v > 0) {
    var sextant;
    var fract, vsf, mid1, mid2, m, sv;
    m = l + l - v;
    sv = (v - m ) / v;

    sextant = intr(h*6.0);
    fract = (h*6.0) - sextant;
    vsf = v * sv * fract;
    mid1 = m + vsf;
    mid2 = v - vsf;
    switch (sextant) {
      case 0: return [v,mid1,m];
      case 1: return [mid2,v,m];
      case 2: return [m,v,mid1];
      case 3: return [m,mid2,v];
      case 4: return [mid1,m,v];
      case 5: return [v,m,mid2];
      case 6: return [0,0,0];
    }
  }
  echo("That was not a color! hsl2rgb()")
  return [0,0,0];
}

function h2rgb(hu) {
  var h = (hu * 360.0) % 360;
  var r = 0, g = 0, b = 0;
  if (h < 0) h = (h + 360);

  if (h <= 120.0) {
    r = ((120.0 - h) / 60.0);
    g = (h / 60.0);
    b = 0.0;
  }
  else if (h <= 240.0) {
    r = 0.0;
    g = ((240.0 - h) / 60.0);
    b = ((h - 120.0) / 60.0);
  }
  else if (h <= 360.0) {
    r = ((h - 240.0) / 60.0);
    g = 0.0;
    b = ((360.0 - h) / 60.0);
  }
 return [Math.min(r,1),Math.min(g,1),Math.min(b,1)];
}

function hsv2rgb(h,s,v) {
  if ((h > 1) || (h < 0)) { echo("H out of range");return [0,0,0]; }
  if ((s > 1) || (s < 0)) { echo("S out of range");return [0,0,0]; }
  if ((v > 1) || (v < 0)) { echo("V out of range");return [0,0,0]; }
  var vv = [1,1,1];
  var c = h2rgb(h);
  c = multv(c, s);
  vv = multv(vv, (1 - s));
  c = addv(c,vv);
  c = multv(c,v);
  return c;
}
